/*
    (c) barsunduk
    05,11/2011
         
      .     :
       ,   (,  ),
       ,   .
       MidletPascal  .
    ( Alexprey)
*/

import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Graphics;

public class Lib_imgs
{
    private static int focus = 0;
    private static int[] pix1 = new int[1];
    private static int Fforecolor = 0xff000000;
    private static boolean Fsolid = false;

    public static void imgsetcolor(int color) {
        Fforecolor = color;
    }
    
    public static int imggetcolor() {
        return Fforecolor;
    }
    
    public static void solid(int value) {
        if(value == 0) {
            Fsolid = false;
        } else Fsolid = true;
    }
    
    public static int getsolid() {
    	if(Fsolid) {
            return 1;
        } else return 0;
    }
    
    public static int getalpha(int col) {
        return (col >> 24) & 0xff;
    }

    public static int getred(int col) {
        return (col >> 16) & 0xff;
    }

    public static int getgreen(int col) {
        return (col >> 8) & 0xff;
    }

    public static int getblue(int col) {
        return col & 0xff;
    }

    public static int argb2int(int alpha, int red, int green, int blue) {
        alpha = (alpha < 0) ? 0 : (alpha & 0xff);
        red = (red < 0) ? 0 : (red & 0xff);
        green = (green < 0) ? 0 : (green & 0xff);
        blue = (blue < 0) ? 0 : (blue & 0xff);
        return (alpha << 24) | (red << 16) | (green << 8) | blue;
    }

    public static String scopy(String s, int offset, int count) {
        int l = s.length();
        count += (offset < 0) ? offset : 0;
        offset = (offset < 0) ? 0 : offset;
        count = (count < 0) ? 0 : count;
        count = (offset + count <= l) ? count : l - offset;
        s = ((offset < l) & (offset + count <= l)) ? String.valueOf(s.toCharArray(), offset, count) : "";
        return s;
    }

    public static String sdelete(String s, int offset, int count) {
        int l = s.length();
        return scopy(s, 0, offset) + scopy(s, offset + count, l - offset - count);
    }

    public static String int2hex(int i)
    {
        return Integer.toHexString(i);
    }

    public static int hex2int(String s) {
        while(s.length() < 8) {
                s = "0" + s;
            }
        String hi = s.substring(0, 4);
        String lo = s.substring(4, s.length());
        return Integer.parseInt(lo, 16) | (Integer.parseInt(hi, 16) << 16);
    }

    public static int pixmix(int forecolor, int backcolor) {
        int a1 = (forecolor >> 24) & 0xff;
        int a2 = (backcolor >> 24) & 0xff;
        int r1 = (forecolor >> 16) & 0xff;
        int r2 = (backcolor >> 16) & 0xff;
        int g1 = (forecolor >> 8) & 0xff;
        int g2 = (backcolor >> 8) & 0xff;
        int b1 = forecolor & 0xff;
        int b2 = backcolor & 0xff;
        int a3 = 255 - a1;
        r1 = (r1 * a1 + r2 * a3) >> 8;
        g1 = (g1 * a1 + g2 * a3) >> 8;
        b1 = (b1 * a1 + b2 * a3) >> 8;
        return ((a2 | a1) << 24) | (r1 << 16) | (g1 << 8) | b1;
    }

    public static Image copyxxyy(int x1, int y1, int x2, int y2) {
        int w;
        int x;
        int h;
        int y;
        if(x2 > x1) {
            w = (x2 - x1);
            x = x1;
        } else {
            w = (x1 - x2);
            x = x2;
        }
        w++;
        if(x < 0) {
            w += x;
            x = 0;
        }
        if(x + w >= M.I.getWidth())
            w = M.I.getWidth() - x;

        if(y2 > y1) {
            h = (y2 - y1);
            y = y1;
        } else {
            h = (y1 - y2);
            y = y2;
        }
        h++;
        if(y < 0) {
            h += y;
            y = 0;
        }
        if(y + h >= M.I.getHeight())
            h = M.I.getHeight() - y;
        return Image.createImage(M.I, x, y, w, h, 0);
    }

    public static Image draw2image(Image imgSource, Image imgDest, int x, int y) {
        int[] bS = null;
        int wS = imgSource.getWidth();
        int hS = imgSource.getHeight();
        bS = new int[wS * hS];
        imgSource.getRGB(bS, 0, wS, 0, 0, wS, hS);
        int[] bD = null;
        int wD = imgDest.getWidth();
        int hD = imgDest.getHeight();
        bD = new int[wD * hD];
        imgDest.getRGB(bD, 0, wD, 0, 0, wD, hD);
        int l = wS * hS;
        int dx = 0;
        int dy = 0;
        int f = 0;
        for(int iy = 0; iy < hS; iy++)
        for(int ix = 0; ix < wS; ix++) {
            dx = x + ix;
            dy = y + iy;
            if((dx >= 0)&&(dy >= 0)&&(dx < wD)&&(dy < hD)) {
                f = dx + dy * wD;
                bD[f] = pixmix(bS[ix + iy * wS], bD[f]);
            }
        }
        bS = null;
        return Image.createRGBImage(bD, wD, hD, true);
    }

    public static Image copyrect(Image img, int x, int y, int w, int h) {
        int iw = img.getWidth();
        int ih = img.getHeight();
        w = (w <= 0) ? 1 : w;
        h = (h <= 0) ? 1 : h;
        if(x < 0) {
            w += x;
            x = 0;
        }
        if(y < 0) {
            h += y;
            y = 0;
        }
        if(x + w >= iw)
            w = iw - x;
        if(y + h >= ih)
            h = ih - y;
        return Image.createImage(img, x, y, w, h, 0);
    }

    public static Image copyscr() {
        return M.I;
    }

    public static Image createimage(int w, int h) {
        w = (w > 0) ? w : 1;
        h = (h > 0) ? h : 1;
        return Image.createImage(w, h);
    }

    public static void setcolorint(int col) {
        M.G.setColor(col);
    }

    public static void setcolorhex(String col) {
        M.G.setColor(hex2int(col));
    }

    public static int getpoint(int x, int y) {
        int w = M.I.getWidth();
        int h = M.I.getHeight();
        int res = 0;
        if((x >= 0)&(y >= 0)&(x < w)&(y < h))
        {
            M.I.getRGB(pix1, 0, w, x, y, 1, 1);
            res = pix1[0];
        }
        return res;
    }

    public static void point(int x, int y, int col) {
        int[] p = new int[1];
        p[0] = col;
        M.G.drawRGB(p, 0, 1, x, y, 1, 1, true);
        p = null;
    }

    public static int getimagepoint(Image img, int x, int y) {
        int w = img.getWidth();
        int h = img.getHeight();
        int res = 0;
        if((x >= 0)&(y >= 0)&(x < w)&(y < h))
        {
            img.getRGB(pix1, 0, w, x, y, 1, 1);
            res = pix1[0];
        }
        return res;
    }

    public static void imagepoint(Image img, int x, int y, int col) {
        int w = img.getWidth();
        int h = img.getHeight();
        int res = 0;
        if((x >= 0)&(y >= 0)&(x < w)&(y < h))
        {
            img.getRGB(pix1, 0, w, x, y, 1, 1);
            pix1[0] = pixmix(pix1[0], col);
                    img.getGraphics().setColor(col);
                    img.getGraphics().drawLine(x, y, x, y);
        }
    }

    public static Image resize(Image img, int w, int h) {
        Image res = Image.createImage(w, h);
        if(img != null)
        {
            int w0 = img.getWidth();
            int h0 = img.getHeight();
            int[] pix = new int[w * h];
            for(int y = 0; y < h; y++)
            for(int x = 0; x < w; x++)
            {
                img.getRGB(pix1, 0, w0, (int) (x * w0 / w), (int) (y * h0 / h), 1, 1);
                pix[y * w + x] = pix1[0];
            }
            res = Image.createRGBImage(pix, w, h, true);
            pix = null;
        }
        return res;
    }

    public static Image repcol(Image img, int col, int newcol) {
        int w = img.getWidth();
        int h = img.getHeight();
        int[] pix = null;
        pix = new int[w * h];
        img.getRGB(pix, 0, w, 0, 0, w, h);
        int l = w * h;
        for(int i = 0; i < l; i++)
        if(pix[i] == col)
        pix[i] = newcol;
        return Image.createRGBImage(pix, w, h, true);
    }

    public static Image addargb(Image img, int da, int dr, int dg, int db) {
        int w = img.getWidth();
        int h = img.getHeight();
        int[] pix = new int[w * h];
        img.getRGB(pix, 0, w, 0, 0, w, h);
        int l = w * h;
        for(int i = 0; i < l; i++) {
            int a = da + (pix[i] >> 24) & 0xff;
            int r = dr + (pix[i] >> 16) & 0xff;
            int g = dg + (pix[i] >> 8) & 0xff;
            int b = db + pix[i] & 0xff;
            a = (a > 255) ? 255 : a;
            a = (a < 0) ? 0 : a;
            r = (r > 255) ? 255 : r;
            r = (r < 0) ? 0 : r;
            g = (g > 255) ? 255 : g;
            g = (g < 0) ? 0 : g;
            b = (b > 255) ? 255 : b;
            b = (b < 0) ? 0 : b;
            pix[i] = (a << 24) | (r << 16) | (g << 8) | b;
        }
        return Image.createRGBImage(pix, w, h, true);
    }

    public static Image setalpha(Image img, int a) {
        int w = img.getWidth();
        int h = img.getHeight();
        int[] pix = new int[w * h];
        img.getRGB(pix, 0, w, 0, 0, w, h);
        int l = w * h;
        a = (a > 255) ? 255 : a;
        a = (a < 0) ? 0 : a;
        for(int i = 0; i < l; i++) {
            int col = pix[i];
            int newa = ((col  & 0xff000000) == 0) ? 0 : a;
            pix[i] = (col & 0xffffff) | (newa << 24);
        }
        return Image.createRGBImage(pix, w, h, true);
    }

    private static int[] _bmp1;
    private static int _bmp1width = 0;
    private static int _bmp1height = 0;

    public static void bmp1free() {
        _bmp1 = null;
        _bmp1width = 0;
        _bmp1height = 0;
    }

    public static void bmp1create(int w, int h) {
        if((w <= 0)|(h <= 0))
            bmp1free();
        else 
            _bmp1 = new int[w * h];
    }

    public static Image bmp1getimage() {
        return Image.createRGBImage(_bmp1, _bmp1width, _bmp1height, true);
    }

    public static void bmp1setimage(Image img) {
        if(img != null)
        {
            _bmp1 = null;
            _bmp1width = img.getWidth();
            _bmp1height = img.getHeight();
            _bmp1 = new int[_bmp1width * _bmp1height];
            img.getRGB(_bmp1, 0, _bmp1width, 0, 0, _bmp1width, _bmp1height);
        }
    }

    public static void setpixel1(int x, int y, int col) {
        if((x >= 0)&(y >= 0)&(x < _bmp1width)&(y < _bmp1height))
            _bmp1[y * _bmp1width + x] = col;
    }

    public static int getpixel1(int x, int y) {
        int col = 0;
        if((x >= 0)&(y >= 0)&(x < _bmp1width)&(y < _bmp1height))
            col = _bmp1[y * _bmp1width + x];
        return col;
    }

    public static int bmp1width() {
        return _bmp1width;
    }

    public static int bmp1height() {
        return _bmp1height;
    }

    private static int[] _bmp2;
    private static int _bmp2width = 0;
    private static int _bmp2height = 0;

    public static void bmp2free() {
        _bmp2 = null;
        _bmp2width = 0;
        _bmp2height = 0;
    }

    public static void bmp2create(int w, int h) {
        if((w <= 0)|(h <= 0))
            bmp2free();
        else 
            _bmp2 = new int[w * h];
    }

    public static Image bmp2getimage() {
        return Image.createRGBImage(_bmp2, _bmp2width, _bmp2height, true);
    }

    public static void bmp2setimage(Image img) {
        if(img != null) {
            _bmp2 = null;
            _bmp2width = img.getWidth();
            _bmp2height = img.getHeight();
            _bmp2 = new int[_bmp2width * _bmp2height];
            img.getRGB(_bmp2, 0, _bmp2width, 0, 0, _bmp2width, _bmp2height);
        }
    }

    public static void setpixel2(int x, int y, int col) {
        if((x >= 0)&(y >= 0)&(x < _bmp2width)&(y < _bmp2height))
            _bmp2[y * _bmp2width + x] = col;
    }

    public static int getpixel2(int x, int y) {
        int col = 0;
        if((x >= 0)&(y >= 0)&(x < _bmp2width)&(y < _bmp2height))
            col = _bmp2[y * _bmp2width + x];
        return col;
    }

    public static int bmp2width() {
        return _bmp2width;
    }

    public static int bmp2height() {
        return _bmp2height;
    }

    //     1?
    private static boolean inrect1(int x, int y) {
        return ((x >= 0)&(y >= 0)&(x < _bmp1width)&(y <= _bmp1height));
    }

    //   1
    public static void bmp1fill(int x, int y, int fillcol) {
        if(inrect1(x, y)) {
        int[] xy = new int[_bmp1width * _bmp1height];
        xy[0] = ((x << 16) | (y & 0xffff));
        int cnt = 1;
        int col = getpixel1(x, y);
        while(cnt > 0) {
            if(inrect1(x, y)) {
                int ix = 1; int iy = 0;
                if(inrect1(x + ix, y + iy) & (getpixel1(x + ix, y + iy) == col)) {
                    xy[cnt] = (((x + ix) << 16) | ((y + iy) & 0xffff));
                    cnt++;
                }
                ix = -1; iy = 0;
                if(inrect1(x + ix, y + iy) & (getpixel1(x + ix, y + iy) == col)) {
                    xy[cnt] = (((x + ix) << 16) | ((y + iy) & 0xffff));
                    cnt++;
                }
                ix = 0; iy = 1;
                if(inrect1(x + ix, y + iy) & (getpixel1(x + ix, y + iy) == col)) {
                    xy[cnt] = (((x + ix) << 16) | ((y + iy) & 0xffff));
                    cnt++;
                }
                ix = 0; iy = -1;
                if(inrect1(x + ix, y + iy) & (getpixel1(x + ix, y + iy) == col)) {
                    xy[cnt] = (((x + ix) << 16) | ((y + iy) & 0xffff));
                    cnt++;
                }
            }
            if(cnt >= 0) {
                setpixel1(x, y, fillcol);
                cnt--;
                if(cnt >= 0) y = (xy[cnt] & 0xffff);
                if(cnt >= 0) x = ((xy[cnt] >> 16) & 0xffff);
            }
        }
        xy = null;
        }
    }

    //     2?
    private static boolean inrect2(int x, int y) {
        return ((x >= 0)&(y >= 0)&(x < _bmp2width)&(y <= _bmp2height));
    }

    //   2
    public static void bmp2fill(int x, int y, int fillcol) {
        if(inrect2(x, y)) {
        int[] xy = new int[_bmp2width * _bmp2height];
        xy[0] = ((x << 16) | (y & 0xffff));
        int cnt = 1;
        int col = getpixel2(x, y);
        while(cnt > 0) {
            if(inrect2(x, y)) {
                int ix = 1; int iy = 0;
                if(inrect2(x + ix, y + iy) & (getpixel2(x + ix, y + iy) == col)) {
                    xy[cnt] = (((x + ix) << 16) | ((y + iy) & 0xffff));
                    cnt++;
                }
                ix = -1; iy = 0;
                if(inrect2(x + ix, y + iy) & (getpixel2(x + ix, y + iy) == col)) {
                    xy[cnt] = (((x + ix) << 16) | ((y + iy) & 0xffff));
                    cnt++;
                }
                ix = 0; iy = 1;
                if(inrect2(x + ix, y + iy) & (getpixel2(x + ix, y + iy) == col)) {
                    xy[cnt] = (((x + ix) << 16) | ((y + iy) & 0xffff));
                    cnt++;
                }
                ix = 0; iy = -1;
                if(inrect2(x + ix, y + iy) & (getpixel2(x + ix, y + iy) == col)) {
                    xy[cnt] = (((x + ix) << 16) | ((y + iy) & 0xffff));
                    cnt++;
                }
            }
            if(cnt >= 0) {
                setpixel2(x, y, fillcol);
                cnt--;
                if(cnt >= 0) y = (xy[cnt] & 0xffff);
                if(cnt >= 0) x = ((xy[cnt] >> 16) & 0xffff);
            }
        }
        xy = null;
        }
    }

    private static int[] bmp = null;
    
    //   
    private static int bw = 0;
    private static int bh = 0;

    //     
    public static void free() {
        bmp = null;
    }
    
    //       
    private static void img2bmp(Image img) {
        bw = img.getWidth();
        bh = img.getHeight();
        bmp = null;
        bmp = new int[bw * bh];
        img.getRGB(bmp, 0, bw, 0, 0, bw, bh);
        img = null;
    }
    
    //     
    private static boolean inrect(int x, int y) {
        if((x >= 0)&&(y >= 0)&&(x < bw)&&(y < bh)) {
            return true;
        } else return false;
    }
    
    //     
    private static int getpix(int x, int y) {
    	if(inrect(x, y)) {
            return bmp[x + y * bw];
    	} else return 0;
    }

    //    
    private static void plot(int x, int y) {
    	if(inrect(x, y)) {
    	    int from = x + y * bw;
    	    if(Fsolid) {
    	        bmp[from] = Fforecolor;
    	    } else {
    	        bmp[from] = pixmix(Fforecolor, bmp[from]);
    	    }
    	}
    }
    
    //    
    private static int abs(int x) {
        if(x < 0) {
            return -x;
        } else return x;
    }
    
    //   
    private static int sign (int x) {
        return (x > 0) ? 1 : (x < 0) ? -1 : 0;
        // 0,   (x)  ; -1,  x < 0  1,  x > 0.
    }
 
    //    
    private static void line(int xstart, int ystart, int xend, int yend) {
        int x, y, dx, dy, incx, incy, pdx, pdy, es, el, err;
        dx = xend - xstart;//   
        dy = yend - ystart;//   
        incx = sign(dx);
        // ,      .  dx < 0, ..  
        //    ,  incx   -1.
        //      .
        //
        incy = sign(dy);
        // .      -
        //      y ( - ).
        dx = abs(dx);//   : "if(dx < dy)"
        dy = abs(dy);//   dx = |dx|; dy = |dy|
        //  :
        if(dx > dy) {
        //  dx > dy,    ""   , ..   ,  .
        //         ( el = dx;),  ""   
        //     ,        (pdx = incx;),  
        //  y   .
            pdx = incx;
            pdy = 0;
            es = dy;
            el = dx;
        } else { //,    "",  , ..    y
            pdx = 0;
            pdy = incy;
            es = dx;
            el = dy; //      y
        }
        x = xstart;
        y = ystart;
        err = el / 2;
        int lastx = x;
        int lasty = y;
        plot(x, y);//  
        //     ,     
        for(int t = 0; t < el; t++) { //   ,      
            err -= es;
            if(err < 0) {
                err += el;
                x += incx;//  (   ,     )
                y += incy;//  -,     y
            } else {
                x += pdx;//   , ..    , 
                y += pdy;//   ;    ,   y
            }
            if((lastx != x)||(lasty != y)) {
                plot(x, y);
                lastx = x;
                lasty = y;
            }
        }
    }

    //    ,       
    private static void line2(int xstart, int ystart, int xend, int yend) {
        int x, y, dx, dy, incx, incy, pdx, pdy, es, el, err;
        dx = xend - xstart;//   
        dy = yend - ystart;//   
        incx = sign(dx);
        // ,      .  dx < 0, ..  
        //    ,  incx   -1.
        //      .
        //
        incy = sign(dy);
        // .      -
        //      y ( - ).
        dx = abs(dx);//   : "if(dx < dy)"
        dy = abs(dy);//   dx = |dx|; dy = |dy|
        //  :
        if(dx > dy) {
        //  dx > dy,    ""   , ..   ,  .
        //         ( el = dx;),  ""   
        //     ,        (pdx = incx;),  
        //  y   .
            pdx = incx;
            pdy = 0;
            es = dy;
            el = dx;
        } else { //,    "",  , ..    y
            pdx = 0;
            pdy = incy;
            es = dx;
            el = dy; //      y
        }
        x = xstart;
        y = ystart;
        err = el / 2;
        int lastx = x;
        int lasty = y;
        el--; //    1
        //plot(x, y);//    
        //     ,     
        for(int t = 0; t < el; t++) { //   ,      
            err -= es;
            if(err < 0) {
                err += el;
                x += incx;//  (   ,     )
                y += incy;//  -,     y
            } else {
                x += pdx;//   , ..    , 
                y += pdy;//   ;    ,   y
            }
            if((lastx != x)||(lasty != y)) {
                plot(x, y);
                lastx = x;
                lasty = y;
            }
        }
    }

    //    
    private static void ellipse(int x, int y, int w, int h) {
        int a = w / 2;
        int b = h / 2;
        x += a;
        y += b;
        int col, i, row, bnew;
        int a_square, b_square, two_a_square, two_b_square, four_a_square, four_b_square, d;
        b_square = b * b;
        a_square = a * a;
        row = b;
        col = 0;
        two_a_square = a_square << 1;
        four_a_square = a_square << 2;
        four_b_square = b_square << 2;
        two_b_square = b_square << 1;
        d = two_a_square * ((row - 1) * (row)) + a_square+two_b_square * (1 - a_square);
        while(a_square * (row) > b_square * (col)) {
                plot(col + x, row + y);
                plot(col + x, y - row);
                if(col + x != x - col) plot(x - col, row + y);
                if(row + y != y - row) plot(x - col, y - row);
            if(d >= 0) {
                row--;
                d -= four_a_square * row;
            }
            d += two_b_square * (3 + (col << 1));
            col++;
        }
        d = two_b_square * (col + 1) * col + two_a_square * (row * (row - 2) + 1) + (1 - two_a_square) * b_square;
        while(row != -1) {
                plot(col + x, row + y);
                plot(col + x, y - row);
                if(col + x != x - col) plot(x - col, row + y);
                if(row + y != y - row) plot(x - col, y - row);
            if(d <= 0) {
                col++;
                d += four_b_square * col;
            }
            row--;
            d += two_a_square * (3 - (row << 1));
        }
    }

    //      
    private static void fillellipse(int x, int y, int w, int h) {
        int a = w / 2;
        int b = h / 2;
        x += a;
        y += b;
        int col, i, row, bnew;
        int a_square, b_square, two_a_square, two_b_square, four_a_square, four_b_square, d;
        b_square = b * b;
        a_square = a * a;
        row = b;
        col = 0;
        two_a_square = a_square << 1;
        four_a_square = a_square << 2;
        four_b_square = b_square << 2;
        two_b_square = b_square << 1;
        d = two_a_square * ((row - 1) * (row)) + a_square+two_b_square * (1 - a_square);
        int lc = col - 1;
        while(a_square * (row) > b_square * (col)) {
            if(lc != col) {
                line(col + x, row + y, col + x, y - row);
                if((row + y != y - row)&&(col + x != x - col)) line(x - col, row + y, x - col, y - row);
                lc = col;
            }
            if(d >= 0) {
                row--;
                d -= four_a_square * row;
            }
            d += two_b_square * (3 + (col << 1));
            col++;
        }
        d = two_b_square * (col + 1) * col + two_a_square * (row * (row - 2) + 1) + (1 - two_a_square) * b_square;
        lc = col - 1;
        while(row != -1) {
            if(lc != col) {
                line(col + x, row + y, col + x, y - row);
                if((row + y != y - row)&&(col + x != x - col)) line(x - col, row + y, x - col, y - row);
                lc = col;
            }
            if(d <= 0) {
                col++;
                d += four_b_square * col;
            }
            row--;
            d += two_a_square * (3 - (row << 1));
        }
    }

    // 
    private static void rect(int x, int y, int w, int h) {
        //  
        line2(x, y, x + w - 1, y);
        //  
        line2(x, y + h - 1, x + w - 1, y + h - 1);
        //  
        line2(x, y, x, y + h - 1);
        //  
        line2(x + w - 1, y, x + w - 1, y + h - 1);
    }
    
    //  
    public static void fillrect(int x, int y, int w, int h) {
        int dx = 0;
        int dy = 0;
        x = (x < 0) ? 0 : x;
        y = (y < 0) ? 0 : y;
        x = (x >= w) ? w - 1 : x;
        y = (y >= h) ? h - 1 : y;
        for(int iy = 0; iy < h; iy++)
        for(int ix = 0; ix < w; ix++) {
            plot(x + ix, y + iy);
        }
    }

    // 
    public static void fill(int x, int y) {
        if(inrect(x, y)) {
            int col = getpix(x, y);
            if(col != Fforecolor) {
                int[] stack = new int[bw * bh];
                int stackpos = 0;
                stack[stackpos] = x | (y << 16);
                while(stackpos >= 0) {
                    int xy = stack[stackpos];
                    stackpos--;
                    x = xy & 0xffff;
                    y = xy >> 16;
                    plot(x, y);
                    int pp;
                    for(int ix = -1; ix <= 1; ix++)
                    for(int iy = -1; iy <= 1; iy++)
                    if(abs(ix) != abs(iy)) {
                        int x2 = x + ix;
                        int y2 = y + iy;
                        if(inrect(x2, y2)) {
                            pp = x2 + y2 * bw;
                            if(bmp[pp] == col) {
                                stackpos++;
                                stack[stackpos] = x2 | (y2 << 16);
                            }
                        }
                    }
                }
                stack = null;
            }
        }
    }

    //   * 65535
    private static final int[] cos_table_180 = {
        65536, 65470, 65470, 65404, 65339, 65273, 65142, 65011, 64880, 64684,
        64487, 64290, 64094, 63832, 63569, 63242, 62980, 62652, 62324, 61931,
        61538, 61145, 60751, 60293, 59834, 59375, 58851, 58392, 57802, 57278,
        56754, 56164, 55574, 54919, 54329, 53673, 53018, 52297, 51642, 50921,
        50200, 49414, 48693, 47906, 47120, 46333, 45481, 44630, 43843, 42991,
        42074, 41222, 40304, 39387, 38469, 37552, 36634, 35651, 34668, 33751,
        32768, 31719, 30736, 29687, 28704, 27656, 26607, 25559, 24510, 23461,
        22413, 21299, 20250, 19136, 18022, 16908, 15794, 14680, 13565, 12451,
        11337, 10223, 9109, 7929, 6815, 5701, 4521, 3407, 2228, 1114, 0,
        -1114, -2228, -3407, -4521, -5701, -6815, -7929, -9109, -10223,
        -11337, -12451, -13565, -14680, -15794, -16908, -18022, -19136, -20250, -21299,
        -22413, -23461, -24510, -25559, -26607, -27656, -28704, -29687, -30736, -31719,
        -32702, -33751, -34668, -35651, -36634, -37552, -38469, -39387, -40304, -41222,
        -42074, -42991, -43843, -44630, -45481, -46333, -47120, -47906, -48693, -49414,
        -50200, -50921, -51642, -52297, -53018, -53673, -54329, -54919, -55574, -56164,
        -56754, -57278, -57802, -58392, -58851, -59375, -59834, -60293, -60751, -61145,
        -61538, -61931, -62324, -62652, -62980, -63242, -63569, -63832, -64094, -64290,
        -64487, -64684, -64880, -65011, -65142, -65273, -65339, -65404, -65470, -65470,
        -65536
    };

    //  
    //     65536 (>> 16)
    public static int cos(int a) {
        int c = 0;
        a %= 360;
        a = (a < 0) ? 360 + a : a;
        if(a > 180) {
            c = -cos_table_180[a - 180];
        } else {
            c = cos_table_180[a];
        }
        return c;
    }

    //  
    //     65536 (>> 16)
    public static int sin(int a) {
        return cos(90 - a);
    }

    //    
    private static int stp(int a, int b, int i) {
        int da = (b - a);
        return (a + ((i * da) >> 4));
    }

    //    
    private static void bezier(int x1, int y1, int x2, int y2, int x3, int y3) {
        int lx = x1;
        int ly = y1;
        for(int i = 0; i <= 16; i++) {
            int x12 = stp(x1, x2, i);
            int y12 = stp(y1, y2, i);
            int x23 = stp(x2, x3, i);
            int y23 = stp(y2, y3, i);
            int x = stp(x12, x23, i);
            int y = stp(y12, y23, i);
            line(lx, ly, x, y);
            lx = x;
            ly = y;
        }
    }

    //     (2-    )
    private static void bow(int x1, int y1, int x2, int y2, int x3, int y3) {
        bezier(x1, y1, ((x2 << 2) - x1 - x3) >> 1, ((y2 << 2) - y1 - y3) >> 1, x3, y3);
    }

    //   
    // x -   , w -  (), a - 
    private static int getax(int x, int w, int a) {
        int w2 = w >> 1;
        return x + w2 + ((cos(a) * w2) >> 16);
    }

    //   
    // y -  , h -  (), a - 
    private static int getay(int y, int h, int a) {
        int h2 = h >> 1;
        return y + h2 + ((sin(a) * h2) >> 16);
    }

    //  
    private static void arc(int x, int y, int w, int h, int a1, int a2) {
        int aa1 = abs(a1);
        aa1 %= 360;
        if(a1 < 0) aa1 = 360 - aa1;
        int aa2 = abs(a2);
        aa2 %= 360;
        if(a2 < 0) aa2 = 360 - aa2;
        int lx = getax(x, w, aa1);
        int ly = getay(y, h, aa1);
        int bl = aa2 - aa1;
        if(bl < 0) bl += 360;
        for(int i = 0; i <= bl; i++) {
            int ii = abs(aa1);
            ii %= 360;
            if(aa1 < 0) ii = 360 - ii;
            int xx = getax(x, w, ii);
            int yy = getay(y, h, ii);
            if(xx >= x + w) xx = x + w - 1;
            if(yy >= y + h) yy = y + h - 1;
            line(lx, ly, xx, yy);
            lx = xx;
            ly = yy;
            aa1--;
        }
    }

    // 
    private static void triangle(int x1, int y1, int x2, int y2, int x3, int y3) {
        //   p1(x1, y1),
        // p2(x2, y2), p3(x3, y3)
        if(y2 < y1) {
            x1 ^= x2; x2 ^= x1; x1 ^= x2;
            y1 ^= y2; y2 ^= y1; y1 ^= y2;
        } //  p1, p2 
        if(y3 < y1) {
            x1 ^= x3; x3 ^= x1; x1 ^= x3;
            y1 ^= y3; y3 ^= y1; y1 ^= y3;
        } //  p1, p3 
        //  p1  
        //   p2  p3
        if(y3 < y2) {
            x2 ^= x3; x3 ^= x2; x2 ^= x3;
            y2 ^= y3; y3 ^= y2; y2 ^= y3;
        }
        //    x   
        // 
        int dx13 = 0, dx12 = 0, dx23 = 0;
        //  
        //  ,    
        // , 
        //   
        if(y3 != y1) {
            dx13 = (x3 - x1) << 16;
            dx13 /= y3 - y1;
        } else dx13 = 0;
        if(y2 != y1) {
            dx12 = (x2 - x1) << 16;
            dx12 /= (y2 - y1);
        } else dx12 = 0;
        if(y3 != y2) {
            dx23 = (x3 - x2) << 16;
            dx23 /= (y3 - y2);
        } else dx23 = 0;
        // " "
        //      
        int wx1 = x1 << 16;
        int wx2 = wx1;
        //   dx13   
        int _dx13 = dx13;
        //    , 
        //    
        //  wx1    wx2
        if(dx13 > dx12) {
            dx12 ^= dx13; dx13 ^= dx12; dx12 ^= dx13;
        }
        int lx1 = wx1;
        int lx2 = wx2;
        //   
        for(int i = y1; i < y2; i++) {
            //      
            plot(wx1 >> 16, i);
            plot(wx2 >> 16, i);
            line2(lx1 >> 16, i - 1, (wx1 >> 16), i);
            line2(lx2 >> 16, i - 1, (wx2 >> 16), i);
            lx1 = wx1;
            lx2 = wx2;
            wx1 += dx13;
            wx2 += dx12;
        }
        //  ,    
        //       x,
        // ..   
        if(y1 == y2) {
            wx1 = x1 << 16;
            wx2 = x2 << 16;
        }
        //  
        // (  )
        dx13 = _dx13;
        if(dx13 < dx23) {
            dx23 ^= dx13; dx13 ^= dx23; dx23 ^= dx13;
        }
        lx1 = wx1;
        lx2 = wx2;
        //   
        for(int i = y2; i < y3; i++) {
            //      
            plot(wx1 >> 16, i);
            plot(wx2 >> 16, i);
            line2(lx1 >> 16, i - 1, (wx1 >> 16), i);
            line2(lx2 >> 16, i - 1, (wx2 >> 16), i);
            lx1 = wx1;
            lx2 = wx2;
            wx1 += dx13;
            wx2 += dx23;
        }
    }

    //  
    private static void filltriangle(int x1, int y1, int x2, int y2, int x3, int y3) {
        //   p1(x1, y1),
        // p2(x2, y2), p3(x3, y3)
        if(y2 < y1) {
            x1 ^= x2; x2 ^= x1; x1 ^= x2;
            y1 ^= y2; y2 ^= y1; y1 ^= y2;
        } //  p1, p2 
        if(y3 < y1) {
            x1 ^= x3; x3 ^= x1; x1 ^= x3;
            y1 ^= y3; y3 ^= y1; y1 ^= y3;
        } //  p1, p3 
        //  p1  
        //   p2  p3
        if(y3 < y2) {
            x2 ^= x3; x3 ^= x2; x2 ^= x3;
            y2 ^= y3; y3 ^= y2; y2 ^= y3;
        }
        //    x   
        // 
        int dx13 = 0, dx12 = 0, dx23 = 0;
        //  
        //  ,    
        // , 
        //   
        if(y3 != y1) {
            dx13 = (x3 - x1) << 16;
            dx13 /= y3 - y1;
        } else dx13 = 0;
        if(y2 != y1) {
            dx12 = (x2 - x1) << 16;
            dx12 /= (y2 - y1);
        } else dx12 = 0;
        if(y3 != y2) {
            dx23 = (x3 - x2) << 16;
            dx23 /= (y3 - y2);
        } else dx23 = 0;
        // " "
        //      
        int wx1 = x1 << 16;
        int wx2 = wx1;
        //   dx13   
        int _dx13 = dx13;
        //    , 
        //    
        //  wx1    wx2
        if(dx13 > dx12) {
            dx12 ^= dx13; dx13 ^= dx12; dx12 ^= dx13;
        }
        //   
        for(int i = y1; i < y2; i++) {
            //      
            for(int j = (wx1 >> 16); j <= (wx2 >> 16); j++) {
                plot(j, i);
            }
            wx1 += dx13;
            wx2 += dx12;
        }
        //  ,    
        //       x,
        // ..   
        if(y1 == y2) {
            wx1 = x1 << 16;
            wx2 = x2 << 16;
        }
        //  
        // (  )
        dx13 = _dx13;
        if(dx13 < dx23) {
            dx23 ^= dx13; dx13 ^= dx23; dx23 ^= dx13;
        }
        //   
        for(int i = y2; i <= y3; i++) {
            //      
            for(int j = (wx1 >> 16); j <= (wx2 >> 16); j++) {
                plot(j, i);
            }
            wx1 += dx13;
            wx2 += dx23;
        }
    }

    //   
    public static Image imgline(Image img, int x1, int y1, int x2, int y2) {
        img2bmp(img);
        line(x1, y1, x2, y2);
        return Image.createRGBImage(bmp, bw, bh, true);
    }

    //   
    public static Image imgrect(Image img, int x, int y, int w, int h) {
        img2bmp(img);
        rect(x, y, w, h);
        return Image.createRGBImage(bmp, bw, bh, true);
    }

    //    
    public static Image imgfillrect(Image img, int x, int y, int w, int h) {
        img2bmp(img);
        fillrect(x, y, w, h);
        return Image.createRGBImage(bmp, bw, bh, true);
    }

    //   
    public static Image imgellipse(Image img, int x, int y, int w, int h) {
        //return imgarc(img, x, y, w, h, 0, 360);
        img2bmp(img);
        ellipse(x, y, w, h);
        return Image.createRGBImage(bmp, bw, bh, true);
    }

    //    
    public static Image imgfillellipse(Image img, int x, int y, int w, int h) {
        img2bmp(img);
        fillellipse(x, y, w, h);
        return Image.createRGBImage(bmp, bw, bh, true);
    }

    //   
    public static Image imgfill(Image img, int x, int y) {
        img2bmp(img);
        fill(x, y);
        return Image.createRGBImage(bmp, bw, bh, true);
    }
    
    //   
    public static Image imgarc(Image img, int x, int y, int w, int h, int a1, int a2) {
        img2bmp(img);
        arc(x, y, w, h, a1, a2);
        return Image.createRGBImage(bmp, bw, bh, true);
    }

    //    (     )
    public static Image imgbow(Image img, int x1, int y1, int x2, int y2, int x3, int y3) {
        img2bmp(img);
        bow(x1, y1, x2, y2, x3, y3);
        return Image.createRGBImage(bmp, bw, bh, true);
    }

    //    (2-      )
    public static Image imgbezier(Image img, int x1, int y1, int x2, int y2, int x3, int y3) {
        img2bmp(img);
        bezier(x1, y1, x2, y2, x3, y3);
        return Image.createRGBImage(bmp, bw, bh, true);
    }

    //   
    public static Image imgtriangle(Image img, int x1, int y1, int x2, int y2, int x3, int y3) {
        img2bmp(img);
        triangle(x1, y1, x2, y2, x3, y3);
        return Image.createRGBImage(bmp, bw, bh, true);
    }

    //    
    public static Image imgfilltriangle(Image img, int x1, int y1, int x2, int y2, int x3, int y3) {
        img2bmp(img);
        filltriangle(x1, y1, x2, y2, x3, y3);
        return Image.createRGBImage(bmp, bw, bh, true);
    }
    
    //  
    public static void scrfill(int x, int y) {
        int tmp = Fforecolor;
        Fforecolor = M.G.getColor();
        img2bmp(M.I);
        fill(x, y);
        M.G.drawRGB(bmp, 0, bw, 0, 0, bw, bh, false);
        bmp = null;
        Fforecolor = tmp;
    }

    public static void clsa(int col) {
        int tmp = Fforecolor;
        Fforecolor = col;
        bmp = null;
        bw = M.I.getWidth();
        bh = M.I.getHeight();
        bmp = new int[bw * bh];
        fillrect(0, 0, bw, bh);
        M.G.drawRGB(bmp, 0, bw, 0, 0, bw, bh, true);
        bmp = null;
        Fforecolor = tmp;
    }

    public static void cls(int col) {
        bmp = null;
        bw = M.I.getWidth();
        bh = M.I.getHeight();
        int l = bw * bh;
        bmp = new int[l];
        for(int i = 0; i < l; i++) bmp[i] = col;
        M.G.drawRGB(bmp, 0, bw, 0, 0, bw, bh, false);
        bmp = null;
    }
    
}